# SQL Manager 2005 Lite for MySQL 3.7.5.1
# ---------------------------------------
# Host     : 127.0.0.1
# Port     : 3306
# Database : bts9_rpt


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES gbk */;

SET FOREIGN_KEY_CHECKS=0;

CREATE DATABASE IF NOT EXISTS `bts9_rpt`
    CHARACTER SET 'utf8'
    COLLATE 'utf8_general_ci';

USE `bts9_rpt`;

DELIMITER //

DROP PROCEDURE IF EXISTS proc_create_bts9_rpt_db;
CREATE PROCEDURE proc_create_bts9_rpt_db() COMMENT 'bts9_rptеĸ'
BEGIN
	DECLARE _b_name	varchar(64) DEFAULT '';    /*ձֶ*/
	
	SET _b_name = '';
	
	#
	# Structure for the `alarm` table : 
	#

	CREATE TABLE IF NOT EXISTS `alarm` (
	  `seq_id` int(11) NOT NULL AUTO_INCREMENT COMMENT '˳ID',
	  `bar_id` int(10) unsigned NOT NULL COMMENT 'ID',
	  `chl` char(32) NOT NULL COMMENT 'ͨ',
	  `log` text NOT NULL COMMENT 'ԭ',
	  `stat` tinyint(4) NOT NULL COMMENT '״̬(0:δ, 1Ѵ)',
	  `upd_dt` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'ʱ',
	  PRIMARY KEY (`seq_id`),
	  KEY `Index_bar_id` (`bar_id`)
	) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='澯Ϣ';

	#
	# Structure for the `alarm_hist` table : 
	#

	CREATE TABLE IF NOT EXISTS `alarm_hist` (
	  `seq_id` int(11) NOT NULL AUTO_INCREMENT COMMENT '˳ID',
	  `bar_id` int(10) unsigned NOT NULL COMMENT 'ID',
	  `chl` char(32) NOT NULL COMMENT 'ͨ',
	  `log` text NOT NULL COMMENT 'ԭ',
	  `stat` tinyint(4) NOT NULL COMMENT '״̬(0:δ, 1Ѵ)',
	  `upd_dt` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'ʱ',
	  PRIMARY KEY (`seq_id`)
	) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='ʷ澯Ϣ';

	#
	# Structure for the `barcode` table : 
	#

	CREATE TABLE IF NOT EXISTS `barcode` (
	  `bar_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'ID',
	  `task_id` int(10) unsigned NOT NULL COMMENT 'ID',
	  `barcode` char(255) NOT NULL COMMENT '',
	  `cycle_count` int(10) unsigned DEFAULT '0' COMMENT 'ѭ',
	  `upd_dt` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'ʱ',
	  PRIMARY KEY (`bar_id`),
	  KEY `Index_task_id` (`task_id`),
	  KEY `Index_barcode` (`barcode`)
	) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='';

	#
	# Structure for the `barcode_hist` table : 
	#

	CREATE TABLE IF NOT EXISTS `barcode_hist` (
	  `bar_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'ID',
	  `task_id` int(10) unsigned NOT NULL COMMENT 'ID',
	  `barcode` char(255) NOT NULL COMMENT '',
	  `cycle_count` int(10) unsigned DEFAULT '0' COMMENT 'ѭ',
	  `upd_dt` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'ʱ',
	  PRIMARY KEY (`bar_id`),
	  KEY `Index_task_id` (`task_id`),
	  KEY `Index_barcode` (`barcode`)
	) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='ʷ';

	#
	# Structure for the `barcode_hist_par` table : 
	#

	CREATE TABLE IF NOT EXISTS `barcode_hist_par` (
	  `bar_id` int(11) NOT NULL COMMENT 'ID',
	  `std_cap` double DEFAULT '0' COMMENT '׼',
	  `group_v` char(32) DEFAULT '' COMMENT '',
	  `area_v` char(32) DEFAULT '' COMMENT '',
	  `upd_dt` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'ʱ',
	  PRIMARY KEY (`bar_id`)
	) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='ʷ';

	#
	# Structure for the `barcode_par` table : 
	#

	CREATE TABLE IF NOT EXISTS `barcode_par` (
	  `bar_id` int(11) NOT NULL COMMENT 'ID',
	  `std_cap` double DEFAULT '0' COMMENT '׼',
	  `group_v` char(32) DEFAULT '' COMMENT '',
	  `area_v` char(32) DEFAULT '' COMMENT '',
	  `upd_dt` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'ʱ',
	  PRIMARY KEY (`bar_id`)
	) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='';

	#
	# Structure for the `imp` table : 
	#

	CREATE TABLE IF NOT EXISTS `imp` (
	  `bar_id` int(11) NOT NULL COMMENT 'ID',
	  `imp_id` int(11) NOT NULL COMMENT '',
	  `value` double NOT NULL COMMENT '',
	  `upd_dt` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'ʱ',
	  PRIMARY KEY (`bar_id`,`imp_id`)
	) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='';

	#
	# Structure for the `imp_hist` table : 
	#

	CREATE TABLE IF NOT EXISTS `imp_hist` (
	  `bar_id` int(11) NOT NULL COMMENT 'ID',
	  `imp_id` int(11) NOT NULL COMMENT '',
	  `value` double NOT NULL COMMENT '',
	  `upd_dt` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'ʱ',
	  PRIMARY KEY (`bar_id`,`imp_id`)
	) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='ʷ';

	#
	# Structure for the `ocv` table : 
	#

	CREATE TABLE IF NOT EXISTS `ocv` (
	  `bar_id` int(11) NOT NULL COMMENT 'ID',
	  `ocv_id` int(11) NOT NULL COMMENT '·ѹ',
	  `value` double NOT NULL COMMENT '·ѹ',
	  `upd_dt` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'ʱ',
	  PRIMARY KEY (`bar_id`,`ocv_id`)
	) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='·ѹ';

	#
	# Structure for the `ocv_hist` table : 
	#

	CREATE TABLE IF NOT EXISTS `ocv_hist` (
	  `bar_id` int(11) NOT NULL COMMENT 'ID',
	  `ocv_id` int(11) NOT NULL COMMENT '·ѹ',
	  `value` double NOT NULL COMMENT '·ѹ',
	  `upd_dt` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'ʱ',
	  PRIMARY KEY (`bar_id`,`ocv_id`)
	) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='·ѹʷ';
	
	SET _b_name = '';
    SELECT IFNULL(table_name, '') INTO _b_name  FROM information_schema.tables
    WHERE table_name = 'sys_par' AND table_schema = 'bts9_rpt' LIMIT 1;
    
    IF _b_name = '' THEN    /**/
        #
		# Structure for the `sys_par` table : 
		#

		CREATE TABLE IF NOT EXISTS `sys_par` (
		  `par_key` char(32) NOT NULL COMMENT '',
		  `par_val` char(128) NOT NULL COMMENT 'ֵ',
		  `par_desc` varchar(1024) COMMENT '',
		  `upd_dt` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'ʱ',
		  PRIMARY KEY (`par_key`)
		) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='ϵͳ';


        /*==============================================================*/
        /* Table: sys_par                                               */
        /*==============================================================*/
        TRUNCATE TABLE sys_par;
        INSERT INTO sys_par (par_key, par_val, par_desc) VALUES
        ('ReportPath',		'D:\\Neware\\AutoReport\\ReportPath',		'Ŀ¼'),
        ('SchedMode',		'0',								'ģʽ(0--ʱ1)'),
        ('IntSec',			'1800',								'ʱ䣬λ'),
        ('Timer1',			'600',								'ʱʱ䣬λ(=0ʾʹöʱ)'),
        ('Timer2',			'43800',							'ʱʱ䣬λ(=0ʾʹöʱ)'),
        ('CycleMode',		'1',								'ѭͳƷʽ(0Ĭϣ1ȳţ2ȷź)'),
        ('MinFading',		'80',								'Fadingڸֵ澯(λٷֱ)'),
        ('FadingDev',		'2',								'һFadingֵ澯(λٷֱ)'),		
		('EmailAddress',	'test@163.com',						''),
		('EmailPwd',		'123456',							''),
		('SMTPServer',		'stmp.163.com',						'smtpʼ :IP:port'),
		('BtsMinCycle',		'2',								'BTSСѭ');
    ELSE                    /*޸*/
        SET _b_name = '';
    END IF;

	#
	# Structure for the `task_curr` table : 
	#

	CREATE TABLE IF NOT EXISTS `task_curr` (
	  `task_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
	  `name` varchar(1024) NOT NULL DEFAULT '' COMMENT '',
	  `stat` tinyint(4) NOT NULL DEFAULT '0' COMMENT '״̬(0ɣ1У2ʱ3ɣ4ȡ)',
	  `path` text NOT NULL COMMENT '·(:D:\a\b)',
	  `rec_dt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'ʱ',
	  `last_dt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'ϴʱ',
	  `operator` char(255) NOT NULL COMMENT '',
	  `detailed_output` bigint(20) NOT NULL DEFAULT '0' COMMENT 'ϸ',
	  `sheet_output` bigint(20) NOT NULL DEFAULT '0' COMMENT 'Sheetҳ',
	  `upd_dt` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'ʱ',
	  PRIMARY KEY (`task_id`),
	  KEY `Index_name` (`name`(767)),
	  KEY `Index_stat` (`stat`),
	  KEY `Index_last_dt` (`last_dt`)
	) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='ǰ';

	#
	# Structure for the `task_hist` table : 
	#

	CREATE TABLE IF NOT EXISTS `task_hist` (
	  `task_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
	  `name` varchar(1024) NOT NULL DEFAULT '' COMMENT '',
	  `stat` tinyint(4) NOT NULL DEFAULT '0' COMMENT '״̬(0ɣ1У2ʱ3ɣ4ȡ)',
	  `path` text NOT NULL COMMENT '·(:D:\a\b)',
	  `rec_dt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'ʱ',
	  `last_dt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'ϴʱ',
	  `operator` char(255) NOT NULL COMMENT '',
	  `detailed_output` bigint(20) NOT NULL DEFAULT '0' COMMENT 'ϸ',
	  `sheet_output` bigint(20) NOT NULL DEFAULT '0' COMMENT 'Sheetҳ',
	  `upd_dt` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'ʱ',
	  PRIMARY KEY (`task_id`),
	  KEY `Index_name` (`name`(767)),
	  KEY `Index_stat` (`stat`),
	  KEY `Index_last_dt` (`last_dt`)
	) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='ʷ';

	#
	# Structure for the `task_hist_par` table : 
	#

	CREATE TABLE IF NOT EXISTS `task_hist_par` (
	  `task_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
	  `par_id` int(11) NOT NULL COMMENT 'ID',
	  `name` varchar(1024) NOT NULL COMMENT '',
	  `value` varchar(1024) NOT NULL DEFAULT '0' COMMENT 'ֵ',
	  `upd_dt` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'ʱ',
	  PRIMARY KEY (`task_id`,`par_id`),
	  KEY `Index_name` (`name`(767))
	) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='ʷ';

	#
	# Structure for the `task_par` table : 
	#

	CREATE TABLE IF NOT EXISTS `task_par` (
	  `task_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
	  `par_id` int(11) NOT NULL COMMENT 'ID',
	  `name` varchar(1024) NOT NULL COMMENT '',
	  `value` varchar(1024) NOT NULL DEFAULT '0' COMMENT 'ֵ',
	  `upd_dt` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'ʱ',
	  PRIMARY KEY (`task_id`,`par_id`),
	  KEY `Index_name` (`name`(767))
	) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='';

	#
	# Structure for the `thick` table : 
	#

	CREATE TABLE IF NOT EXISTS `thick` (
	  `bar_id` int(11) NOT NULL COMMENT 'ID',
	  `thick_id` int(11) NOT NULL COMMENT '',
	  `value` double NOT NULL COMMENT 'ֵ',
	  `upd_dt` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'ʱ',
	  PRIMARY KEY (`bar_id`,`thick_id`)
	) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='ȱ';

	#
	# Structure for the `thick_hist` table : 
	#

	CREATE TABLE IF NOT EXISTS `thick_hist` (
	  `bar_id` int(11) NOT NULL COMMENT 'ID',
	  `thick_id` int(11) NOT NULL COMMENT '',
	  `value` double NOT NULL COMMENT 'ֵ',
	  `upd_dt` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'ʱ',
	  PRIMARY KEY (`bar_id`,`thick_id`)
	) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='ʷ';

	/*=========================================2018-03-21ʼ===================================================================*/
	
	SET _b_name = '';        
	SELECT IFNULL(column_name, '') INTO _b_name
	FROM information_schema.columns
	WHERE table_name = 'barcode'
	AND column_name = 'barcode_type' AND table_schema = 'bts9_rpt' LIMIT 1;
	
	IF _b_name = '' THEN
		alter table barcode
            Add column barcode_type tinyint(3) NOT NULL default '0' COMMENT '(0:׼ 1:ͨϢ(豸-豸ID-ԪID-ͨID_ID[λNUID-ԪNUID]))' AFTER cycle_count;
	ELSE
		SET _b_name = '';
	END IF; 
	
	SET _b_name = '';        
	SELECT IFNULL(column_name, '') INTO _b_name
	FROM information_schema.columns
	WHERE table_name = 'barcode_hist'
	AND column_name = 'barcode_type' AND table_schema = 'bts9_rpt' LIMIT 1;
	
	IF _b_name = '' THEN
		alter table barcode_hist
            Add column barcode_type tinyint(3) NOT NULL default '0' COMMENT '(0:׼ 1:ͨϢ(豸-豸ID-ԪID-ͨID_ID[λNUID-ԪNUID]))' AFTER cycle_count;
	ELSE
		SET _b_name = '';
	END IF; 
	
	/*=========================================2018-03-21===================================================================*/
END;

CALL proc_create_bts9_rpt_db();

DROP TRIGGER IF EXISTS alarm_before_del_tr;
CREATE TRIGGER `alarm_before_del_tr` BEFORE DELETE ON `alarm`
  FOR EACH ROW
BEGIN
    INSERT INTO alarm_hist
        (seq_id, bar_id, chl, log, stat, upd_dt)
    VALUES
        (OLD.seq_id, OLD.bar_id, OLD.chl, OLD.log, OLD.stat, OLD.upd_dt);
END;

DROP TRIGGER IF EXISTS barcode_before_del_tr;
CREATE TRIGGER `barcode_before_del_tr` BEFORE DELETE ON `barcode`
  FOR EACH ROW
BEGIN
    INSERT INTO barcode_hist
        (bar_id, task_id, barcode, cycle_count, barcode_type, upd_dt)
    VALUES
        (OLD.bar_id, OLD.task_id, OLD.barcode, OLD.cycle_count, OLD.barcode_type, OLD.upd_dt);
END;

DROP TRIGGER IF EXISTS barcode_par_before_del_tr;
CREATE TRIGGER `barcode_par_before_del_tr` BEFORE DELETE ON `barcode_par`
  FOR EACH ROW
BEGIN
    INSERT INTO barcode_hist_par
        (bar_id, std_cap, group_v, area_v, upd_dt)
    VALUES
        (OLD.bar_id, OLD.std_cap, OLD.group_v, OLD.area_v, OLD.upd_dt);
END;

DROP TRIGGER IF EXISTS imp_before_del_tr;
CREATE TRIGGER `imp_before_del_tr` BEFORE DELETE ON `imp`
  FOR EACH ROW
BEGIN
    INSERT INTO imp_hist
        (bar_id, imp_id, value, upd_dt)
    VALUES
        (OLD.bar_id, OLD.imp_id, OLD.value, OLD.upd_dt);
END;

DROP TRIGGER IF EXISTS ocv_before_del_tr;
CREATE TRIGGER `ocv_before_del_tr` BEFORE DELETE ON `ocv`
  FOR EACH ROW
BEGIN
    INSERT INTO ocv_hist
        (bar_id, ocv_id, value, upd_dt)
    VALUES
        (OLD.bar_id, OLD.ocv_id, OLD.value, OLD.upd_dt);
END;

DROP TRIGGER IF EXISTS task_curr_before_del_tr;
CREATE TRIGGER `task_curr_before_del_tr` BEFORE DELETE ON `task_curr`
  FOR EACH ROW
BEGIN
    INSERT INTO task_hist
        (task_id, name, stat, path, rec_dt, last_dt, 
        operator, detailed_output, sheet_output, upd_dt)
    VALUES
        (OLD.task_id, OLD.name, OLD.stat, OLD.path, OLD.rec_dt, 
        OLD.last_dt, OLD.operator, OLD.detailed_output, 
        OLD.sheet_output, OLD.upd_dt);
END;

DROP TRIGGER IF EXISTS task_par_before_del_tr;
CREATE TRIGGER `task_par_before_del_tr` BEFORE DELETE ON `task_par`
  FOR EACH ROW
BEGIN
    INSERT INTO task_hist_par
        (task_id, par_id, name, value, upd_dt)
    VALUES
        (OLD.task_id, OLD.par_id, OLD.name, OLD.value, OLD.upd_dt);
END;

DROP TRIGGER IF EXISTS thick_before_del_tr;
CREATE TRIGGER `thick_before_del_tr` BEFORE DELETE ON `thick`
  FOR EACH ROW
BEGIN
    INSERT INTO thick_hist
        (bar_id, thick_id, value, upd_dt)
    VALUES
        (OLD.bar_id, OLD.thick_id, OLD.value, OLD.upd_dt);
END;

//  
DELIMITER ;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;